Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | METHOD | DETAIL: FIELD | METHOD

## org.vertx.groovy.core.streams
[Groovy] Interface WriteStream

    interface WriteStream

Represents a stream of data that can be written to.

Any class that implements this interface can be used by a Pump to pump data from a `ReadStream` to it.

Authors:
  Tim Fox

Method Summary
`void` | `drainHandler(groovy.lang.Closure handler)` Set a drain handler on the stream.
`void` | `exceptionHandler(groovy.lang.Closure handler)` Set an exception handler on the stream
`boolean` | `isWriteQueueFull()` This will return `true` if there are more bytes in the write queue than the value set using setWriteQueueMaxSize
`void` | `setWriteQueueMaxSize(int maxSize)` Set the maximum size of the write queue to `maxSize`.
`void` | `writeBuffer(Buffer data)` Write some data to the stream.

Method Detail

### drainHandler

    void drainHandler(groovy.lang.Closure handler)

  Set a drain handler on the stream. If the write queue is full, then the handler will be called when the write queue has been reduced to maxSize / 2. See Pump for an example of this being used.

### exceptionHandler

    void exceptionHandler(groovy.lang.Closure handler)

  Set an exception handler on the stream

### isWriteQueueFull

    boolean isWriteQueueFull()

  This will return `true` if there are more bytes in the write queue than the value set using setWriteQueueMaxSize

### setWriteQueueMaxSize

    void setWriteQueueMaxSize(int maxSize)

  Set the maximum size of the write queue to `maxSize`. You will still be able to write to the stream even if there is more than `maxSize` bytes in the write queue. This is used as an indicator by classes such as `Pump` to provide flow control.

### writeBuffer

    void writeBuffer(Buffer data)

  Write some data to the stream. The data is put on an internal write queue, and the write actually happens asynchronously. To avoid running out of memory by putting too much on the write queue, check the isWriteQueueFull method before writing. This is done automatically if using a Pump.

Groovy Documentation